INCLUDE(FindQt4)

set(PROVIDER_CONFIG_MKSPECS_FILE "")
IF(EXISTS "${QT_MKSPECS_DIR}/features/providerconfig.prf")
    set(PROVIDER_CONFIG_MKSPECS_FILE "${QT_MKSPECS_DIR}/features/providerconfig.prf")
    MESSAGE(FATAL_ERROR "DEBUG 1")
ELSEIF(EXISTS "${QT_MKSPECS_DIR}/features/provider.prf")
    set(PROVIDER_CONFIG_MKSPECS_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/providerconfig.prf")
    MESSAGE(FATAL_ERROR "DEBUG 2")
ENDIF()

IF(EXISTS "${QT_MKSPECS_DIR}/features/provider.prf")
    FILE(READ ${QT_MKSPECS_DIR}/features/provider.prf PROVIDER_FILE_CONTENTS)

    STRING(REGEX MATCH "PROVIDER_PREFIX=([^\n]+)" PROVIDER_PREFIX "${PROVIDER_FILE_CONTENTS}")
    SET(PROVIDER_PREFIX ${CMAKE_MATCH_1})

    STRING(REGEX MATCH "PROVIDER_INCLUDE=([^\n]+)" PROVIDER_INCLUDE_DIR "${PROVIDER_FILE_CONTENTS}")
    SET(PROVIDER_INCLUDE_DIR ${CMAKE_MATCH_1})

    STRING(REGEX MATCH "PROVIDER_LIB=([^\n]+)" "\\1" PROVIDER_LIBRARY "${PROVIDER_FILE_CONTENTS}")
    SET(PROVIDER_LIBRARY_DIR ${CMAKE_MATCH_1})

    #VERSION
    IF(NOT ${PROVIDER_CONFIG_MKSPECS_FILE} STREQUAL "")
        FILE(READ ${PROVIDER_CONFIG_MKSPECS_FILE} PROVIDER_CONFIG_FILE_CONTENTS)
        STRING(REGEX MATCH "PROVIDER_VERSION = ([^\n]+)" PROVIDER_VERSION "${PROVIDER_CONFIG_FILE_CONTENTS}")
        SET(PROVIDER_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "PROVIDER_MAJOR_VERSION = ([^\n]+)" PROVIDER_MAJOR_VERSION "${PROVIDER_CONFIG_FILE_CONTENTS}")
        SET(PROVIDER_MAJOR_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "PROVIDER_MINOR_VERSION = ([^\n]+)" PROVIDER_MINOR_VERSION "${PROVIDER_CONFIG_FILE_CONTENTS}")
        SET(PROVIDER_MINOR_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "PROVIDER_PATCH_VERSION = ([^\n]+)" PROVIDER_PATCH_VERSION "${PROVIDER_CONFIG_FILE_CONTENTS}")
        SET(PROVIDER_PATCH_VERSION ${CMAKE_MATCH_1})
    ELSE()
        SET(PROVIDER_VERSION 0.5.16)
        SET(PROVIDER_MAJOR_VERSION 0)
        SET(PROVIDER_MINOR_VERSION 5)
        SET(PROVIDER_PATCH_VERSION 16)
    ENDIF()

    IF(Provider_FIND_VERSION_EXACT)
        IF(PROVIDER_VERSION VERSION_EQUAL Provider_FIND_VERSION)
            SET(PROVIDER_FOUND TRUE)
        ELSE()
            SET(PROVIDER_FOUND FALSE)
            IF(PROVIDER_VERSION VERSION_LESS Provider_FIND_VERSION)
                SET(PROVIDER_TOO_OLD TRUE)
            ELSE()
                SET(PROVIDER_TOO_NEW TRUE)
            ENDIF()
        ENDIF()
    ELSE()
        IF(PROVIDER_VERSION VERSION_LESS Provider_FIND_VERSION)
            SET(PROVIDER_FOUND FALSE)
            SET(PROVIDER_TOO_OLD TRUE)
        ELSE()
            SET(PROVIDER_FOUND TRUE)
        ENDIF()
    ENDIF()
ELSE()
    SET(PROVIDER_FOUND NOTFOUND)
    SET(PROVIDER_PREFIX NOTFOUND)
    SET(PROVIDER_INCLUDE NOTFOUND)
    SET(PROVIDER_LIB NOTFOUND)
ENDIF()

IF(NOT PROVIDER_FOUND)
    if(PROVIDER_TOO_OLD)
        MESSAGE(FATAL_ERROR "The installed Context Provider version ${PROVIDER_VERSION} it too old, version ${Provider_FIND_VERSION} is required.")
    ELSEIF(PROVIDER_TOO_NEW)
        MESSAGE(FATAL_ERROR "The installed Context Provider version ${PROVIDER_VERSION} it too new, version ${Provider_FIND_VERSION} is required.")
    ELSE()
        MESSAGE(FATAL_ERROR "Context Provider not found.")
    ENDIF()
ENDIF()
