INCLUDE(FindQt4)

set(SUBSCRIBER_CONFIG_MKSPECS_FILE "")
IF(EXISTS "${QT_MKSPECS_DIR}/features/subscriberconfig.prf")
    set(SUBSCRIBER_CONFIG_MKSPECS_FILE "${QT_MKSPECS_DIR}/features/subscriberconfig.prf")
ELSEIF(EXISTS "${QT_MKSPECS_DIR}/features/subscriber.prf")
    set(SUBSCRIBER_CONFIG_MKSPECS_FILE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/subscriberconfig.prf")
ENDIF()

IF(EXISTS "${QT_MKSPECS_DIR}/features/subscriber.prf")
    FILE(READ ${QT_MKSPECS_DIR}/features/subscriber.prf SUBSCRIBER_FILE_CONTENTS)

    STRING(REGEX MATCH "SUBSCRIBER_PREFIX=([^\n]+)" SUBSCRIBER_PREFIX "${SUBSCRIBER_FILE_CONTENTS}")
    SET(SUBSCRIBER_PREFIX ${CMAKE_MATCH_1})

    STRING(REGEX MATCH "SUBSCRIBER_INCLUDE=([^\n]+)" SUBSCRIBER_INCLUDE_DIR "${SUBSCRIBER_FILE_CONTENTS}")
    SET(SUBSCRIBER_INCLUDE_DIR ${CMAKE_MATCH_1})

    STRING(REGEX MATCH "SUBSCRIBER_LIB=([^\n]+)" "\\1" SUBSCRIBER_LIBRARY "${SUBSCRIBER_FILE_CONTENTS}")
    SET(SUBSCRIBER_LIBRARY_DIR ${CMAKE_MATCH_1})

    #VERSION
    IF(NOT ${SUBSCRIBER_CONFIG_MKSPECS_FILE} STREQUAL "")
        FILE(READ ${SUBSCRIBER_CONFIG_MKSPECS_FILE} SUBSCRIBER_CONFIG_FILE_CONTENTS)
        STRING(REGEX MATCH "SUBSCRIBER_VERSION = ([^\n]+)" SUBSCRIBER_VERSION "${SUBSCRIBER_CONFIG_FILE_CONTENTS}")
        SET(SUBSCRIBER_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "SUBSCRIBER_MAJOR_VERSION = ([^\n]+)" SUBSCRIBER_MAJOR_VERSION "${SUBSCRIBER_CONFIG_FILE_CONTENTS}")
        SET(SUBSCRIBER_MAJOR_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "SUBSCRIBER_MINOR_VERSION = ([^\n]+)" SUBSCRIBER_MINOR_VERSION "${SUBSCRIBER_CONFIG_FILE_CONTENTS}")
        SET(SUBSCRIBER_MINOR_VERSION ${CMAKE_MATCH_1})

        STRING(REGEX MATCH "SUBSCRIBER_PATCH_VERSION = ([^\n]+)" SUBSCRIBER_PATCH_VERSION "${SUBSCRIBER_CONFIG_FILE_CONTENTS}")
        SET(SUBSCRIBER_PATCH_VERSION ${CMAKE_MATCH_1})
    ELSE()
        SET(SUBSCRIBER_VERSION 1.0.0)
        SET(SUBSCRIBER_MAJOR_VERSION 1)
        SET(SUBSCRIBER_MINOR_VERSION 0)
        SET(SUBSCRIBER_PATCH_VERSION 0)
    ENDIF()

    IF(Subscriber_FIND_VERSION_EXACT)
        IF(SUBSCRIBER_VERSION VERSION_EQUAL Subscriber_FIND_VERSION)
            SET(SUBSCRIBER_FOUND TRUE)
        ELSE()
            SET(SUBSCRIBER_FOUND FALSE)
            IF(SUBSCRIBER_VERSION VERSION_LESS Subscriber_FIND_VERSION)
                SET(SUBSCRIBER_TOO_OLD TRUE)
            ELSE()
                SET(SUBSCRIBER_TOO_NEW TRUE)
            ENDIF()
        ENDIF()
    ELSE()
        IF(SUBSCRIBER_VERSION VERSION_LESS Subscriber_FIND_VERSION)
            SET(SUBSCRIBER_FOUND FALSE)
            SET(SUBSCRIBER_TOO_OLD TRUE)
        ELSE()
            SET(SUBSCRIBER_FOUND TRUE)
        ENDIF()
    ENDIF()
ELSE()
    SET(SUBSCRIBER_FOUND NOTFOUND)
    SET(SUBSCRIBER_PREFIX NOTFOUND)
    SET(SUBSCRIBER_INCLUDE NOTFOUND)
    SET(SUBSCRIBER_LIB NOTFOUND)
ENDIF()

IF(NOT SUBSCRIBER_FOUND)
    if(SUBSCRIBER_TOO_OLD)
        MESSAGE(FATAL_ERROR "The installed Context Subscriber version ${SUBSCRIBER_VERSION} it too old, version ${Subscriber_FIND_VERSION} is required.")
    ELSEIF(SUBSCRIBER_TOO_NEW)
        MESSAGE(FATAL_ERROR "The installed Context Subscriber version ${SUBSCRIBER_VERSION} it too new, version ${Subscriber_FIND_VERSION} is required.")
    ELSE()
        MESSAGE(FATAL_ERROR "Context Subscriber not found.")
    ENDIF()
ENDIF()
