# \class SvgRotateWidget
# \brief Extends SvgWidget functionality by rotation

from PySide.QtCore import *
from PySide.QtGui import *
from PySide.QtSvg import *

class SvgRotateWidget(QSvgWidget):

    UP = 1
    LEFT = 2
    DOWN = 3
    RIGHT = 4

    def __init__(self, filename = None, parent = None):
        super(SvgRotateWidget, self).__init__(parent)
        if filename:
            QSvgWidget(filename, parent)
        else:
            QSvgWidget(parent)
        self.rotationMatrix = QMatrix()

    # Sets the rotation, use the constants UP, LEFT, RIGHT, DOWN
    def setRotation(self, rotation):
        if rotation == self.UP:
            self.rotationMatrix = QMatrix(1, 0, 0, 1, 0, 0)
        elif rotation == self.LEFT:
            self.rotationMatrix = QMatrix(0, -1, 1, 0, 0, self.height())
        elif rotation == self.DOWN:
            self.rotationMatrix = QMatrix(-1, 0, 0, -1, self.width(), self.height())
        elif rotation == self.RIGHT:
            self.rotationMatrix = QMatrix(0, 1, -1, 0, self.width(), 0)

        self.repaint()

    def paintEvent(self, event):
        p = QPainter(self)
        p.setWorldMatrix(self.rotationMatrix)
        self.renderer().render(p)
